create or replace PROCEDURE FATURA_LICENCAUSO_ACEITE
  (P_CDCLIENTE IN VENCLUSOCLIE.CDCLIENTE%TYPE,
   P_CDLINPCLIE IN VENCLUSOCLIE.CDLINPCLIE%TYPE,
   P_CDOPERAPUR IN OPERADOR.CDOPERADOR%TYPE,
   P_COMMIT IN VARCHAR2 := '1')
AS
   V_PRXAPURACAO VARCHAR2(20);
   V_DSBOLETCLIE VARCHAR2(2000);
   V_DSFATURCLIE VARCHAR2(2000);
   V_CDEMPRESA VARCHAR2(2);
   V_CDFILIAL VARCHAR2(4);
   V_CDPRODUTO VARCHAR2(10);
   V_PRODNAC VARCHAR2(10);
   V_PRODINT VARCHAR2(10);
   V_DATA DATE;
   V_MES DATE;
   V_DESCBOLETO VARCHAR2(100);
   V_DSNOTACLIE VARCHAR2(100);
BEGIN
   SELECT TRUNC(SYSDATE), ADD_MONTHS(LAST_DAY(TRUNC(SYSDATE)), -1) + 1
     INTO V_DATA, V_MES
     FROM DUAL;

   SELECT MAX(CDPROFATLUSO), MAX(CDPROFATINTLUSO)
     INTO V_PRODNAC, V_PRODINT
     FROM PAR_GERAL_FAS;

   FOR CUR_VENC IN (SELECT SUM(1) OVER (PARTITION BY V.CDCLIENTE, V.CDLINPCLIE ORDER BY V.CDCLIENTE, V.CDLINPCLIE, V.DTVELUSOPEDC ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) PARCELA,
                           SUM(1) OVER (PARTITION BY V.CDCLIENTE, V.CDLINPCLIE) TOTAL_PARCELA,
                           V.CDCLIENTE, V.CDLINPCLIE, V.DTVELUSOPEDC, C.CDLINPCLIEINFOR, C.NMLINPCLIE,
                           V.VRVELUSOPEDC, NVL(E.CDPAIS, '0055') CDPAIS,
                           C.NRPROPOSFAS, LTRIM(C.NRPROPOSFAS,0) AS NRPROPOSTABOL, C.NRVERPROPFAS
                      FROM VENCLUSOCLIE V, CONTRATOLINP C, ENDECLIE E
                     WHERE V.CDCLIENTE = P_CDCLIENTE
                       AND V.CDLINPCLIE = P_CDLINPCLIE
                       AND C.CDCLIENTE = P_CDCLIENTE
                       AND C.CDLINPCLIE = P_CDLINPCLIE
                       AND ((V.VRVELUSOPEDC > 0) OR (V.VRVELUSOPEDC IS NULL))
                       AND V.NRAPURFATFAS IS NULL
                       AND E.IDTPENDECLIE = 'P'
                       AND E.CDCLIENTE = P_CDCLIENTE
                     ORDER BY V.CDCLIENTE, V.CDLINPCLIE, V.DTVELUSOPEDC) LOOP

      V_DESCBOLETO := '';
      V_DSNOTACLIE := '';

      BEGIN
         SELECT MAX(P.DSBOLETCLIE), MAX(P.DSFATURCLIE), NVL(MAX(P.CDEMPRESA), '01'), NVL(MAX(F.CDFILIAL), '9999') -- ver se pode retornar mais de uma filial
           INTO V_DSBOLETCLIE, V_DSFATURCLIE, V_CDEMPRESA, V_CDFILIAL
           FROM PARCLIEFAS P, FILIAL F
          WHERE P.IDTPFATUCLIE = '2' -- LICENA DE USO
            AND P.CDCLIENTE = CUR_VENC.CDCLIENTE
            AND P.CDEMPRESA = F.CDEMPRESA
            AND ROWNUM = 1;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            NULL;
      END;

      /*A EMPRESA 12 POSSUI 3 FILIAIS, A PEDIDO DA POLIANA SER GERADO O FATURAMENTO SEMPRE PARA A FILIAL 9990*/ 
      IF V_CDEMPRESA = '12' THEN
         V_CDFILIAL := '9990';
      END IF;


      /* conforme acordado com a Poliana,
        a descrio do boleto e da nota sero fixas,
        para que o incluir um novo cliente nao seja necessario alterar a descrio*/
      /*V_DESCBOLETO := V_DSBOLETCLIE;*/
      V_DESCBOLETO := 'Licena de Uso ref proposta COMXXXXXX-XX. Parcela XX/XX.';
      V_DESCBOLETO := REPLACE(V_DESCBOLETO, 'XXXXXX-XX', CUR_VENC.NRPROPOSTABOL||'-'||CUR_VENC.NRVERPROPFAS);

      IF LPAD(CUR_VENC.PARCELA,2,'0') = '01' AND LPAD(CUR_VENC.TOTAL_PARCELA,2,'0') = '01' THEN
         V_DESCBOLETO := REPLACE(V_DESCBOLETO, 'XX/XX', 'nica');
      ELSE
         V_DESCBOLETO := REPLACE(V_DESCBOLETO, 'XX/XX', LPAD(CUR_VENC.PARCELA,2,'0')||'/'||LPAD(CUR_VENC.TOTAL_PARCELA,2,'0'));
      END IF;

      /*V_DSNOTACLIE := V_DSFATURCLIE;*/
      V_DSNOTACLIE := V_DESCBOLETO;

      NOVO_CODIGO('APURFATUFAS', V_PRXAPURACAO);

      IF CUR_VENC.CDPAIS = '0055' THEN
         V_CDPRODUTO := V_PRODNAC;
      ELSE
         V_CDPRODUTO := V_PRODINT;
      END IF;

      INSERT INTO APURFATUFAS (CDFILIAL, CDCLIENTE, NRAPURFATFAS, DTAPURFATFAS,
         CDLINPCLIE, VRTOTAFATFAS, DSEMISSPRONF, CDOPERAPUR, CDEMPRESA,
         CDPRODUTO, IDAPURFATFAS, IDSTAPFATFAS, IDCOMIFATFAS,
         DSBOLEFATFAS, DTMESAPURFAS, CDGRUPONFAPUR)
      VALUES (V_CDFILIAL, CUR_VENC.CDCLIENTE, SUBSTR(V_PRXAPURACAO, 11, 10), V_DATA,
         CUR_VENC.CDLINPCLIE, CUR_VENC.VRVELUSOPEDC, V_DSNOTACLIE, P_CDOPERAPUR, V_CDEMPRESA,
         V_CDPRODUTO, '5', 'P', 'N',
         V_DESCBOLETO, V_MES, '01');

      INSERT INTO LOGLINP (CDCLIENTE, CDOPERADOR, CDLINPCLIE,
         DTOPERLINP, DSOPERLINP, IDOPERLINP)
      VALUES (CUR_VENC.CDCLIENTE, P_CDOPERAPUR, CUR_VENC.CDLINPCLIE,
         SYSDATE, 'Cobrana de licena de uso da linha de produto '||CUR_VENC.CDLINPCLIEINFOR||' '||CUR_VENC.NMLINPCLIE, 'APURACAO_LICENCAUSO');

      UPDATE VENCLUSOCLIE
         SET NRAPURFATFAS = SUBSTR(V_PRXAPURACAO, 11, 10)
       WHERE CDCLIENTE = CUR_VENC.CDCLIENTE
         AND CDLINPCLIE = CUR_VENC.CDLINPCLIE
         AND DTVELUSOPEDC = CUR_VENC.DTVELUSOPEDC;

      V_MES := ADD_MONTHS(V_MES, 1);
   END LOOP;
   
   IF P_COMMIT = '1' THEN
      COMMIT;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('FATURA_LICENCAUSO_ACEITE','5.11.000'); END;
/