/* Sistemas Integrados TEKNISA
  Integrao SPED FISCAL

Nome: C:\Web_407\Srv\Src\Cli\Sky\Sql\0011_LSGFUNO_USR_DESCONTO.SQL

Descrio:
Funo para retornar o valor do desconto rateado por produto.

Criao:
30/03/2010 - Cleison Ferreira
*/
CREATE OR REPLACE FUNCTION USR_DESCONTO
   (P_CDFILIAL     IN ITEMPRODUTO.CDFILIAL%TYPE,
    P_NRLANCTONF   IN ITEMPRODUTO.NRLANCTONF%TYPE,
    P_IDPRODSERV   IN NOTAFISCAL.IDENTRSAIDOP%TYPE) RETURN FLOAT
AS
   V_VRDESCITEM     ITEMPRODUTO.VRDESCITEM%TYPE;
   V_VRDESCFIXO     ITEMPRODUTO.VRDESCITEM%TYPE; /*Cdigos 10 e 11*/
   V_VRDESCDELI     ITEMPRODUTO.VRDESCITEM%TYPE; /*Cdigos 06 e 07*/
   V_VRDESCCOND     ITEMPRODUTO.VRDESCITEM%TYPE; /*Cdigos 12 e 13*/
   V_VRDESCDESV     ITEMPRODUTO.VRDESCITEM%TYPE; /*Cdigos 08 e 09*/
   V_QTITEMPROD     ITEMPRODUTO.QTITEMPROD%TYPE;
BEGIN
   BEGIN
      SELECT E.TOTENTR+S.TOTSAID
        INTO V_QTITEMPROD
        FROM (SELECT COUNT(I.NRLANCTONF) AS TOTENTR
                FROM ITEMPRODUTO I, NOTAFISCAL N,
                      (SELECT I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD
                        FROM ITEMPROIMPOS I, ITEMPRODUTO IT
                       WHERE (I.CDIMPOSTO    = '30')          AND
                             (I.NRITPROIMPOS = '1')           AND
                             (I.CDFILIAL     = P_CDFILIAL)   AND
                             (I.NRLANCTONF   = P_NRLANCTONF) AND
                             (I.CDFILIAL     = IT.CDFILIAL)   AND
                             (I.NRLANCTONF   = IT.NRLANCTONF) AND
                             (I.NRSEQITPROD  = IT.NRSEQITPROD)) SE
                 WHERE I.CDFILIAL     = P_CDFILIAL
                   AND I.NRLANCTONF   = P_NRLANCTONF
                   AND I.CDFILIAL     = N.CDFILIAL
                   AND I.NRLANCTONF   = N.NRLANCTONF
                   AND N.IDENTRSAIDOP = 'E'
                   AND I.CDFILIAL     = SE.CDFILIAL
                   AND I.NRLANCTONF   = SE.NRLANCTONF
                   AND I.NRSEQITPROD  = SE.NRSEQITPROD) E,
             (SELECT COUNT(I.NRLANCTONF) AS TOTSAID
                FROM ITEMPRODUTO I, NOTAFISCAL N,
                     (SELECT I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD
                        FROM ITEMPROIMPOS I, ITEMPRODUTO IT
                       WHERE (I.CDIMPOSTO    = '31')          AND
                             (I.NRITPROIMPOS = '1')           AND
                             (I.CDFILIAL     = P_CDFILIAL)   AND
                             (I.NRLANCTONF   = P_NRLANCTONF) AND
                             (I.CDFILIAL     = IT.CDFILIAL)   AND
                             (I.NRLANCTONF   = IT.NRLANCTONF) AND
                             (I.NRSEQITPROD  = IT.NRSEQITPROD)) SS
                 WHERE I.CDFILIAL     = P_CDFILIAL
                   AND I.NRLANCTONF   = P_NRLANCTONF
                   AND I.CDFILIAL     = N.CDFILIAL
                   AND I.NRLANCTONF   = N.NRLANCTONF
                   AND N.IDENTRSAIDOP = 'S'
                   AND I.CDFILIAL     = SS.CDFILIAL
                   AND I.NRLANCTONF   = SS.NRLANCTONF
                   AND I.NRSEQITPROD  = SS.NRSEQITPROD) S;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_QTITEMPROD := 0;
   END;

   IF P_IDPRODSERV = 'P' THEN
      BEGIN
         SELECT COUNT(I.NRLANCTONF) - V_QTITEMPROD
           INTO V_QTITEMPROD
           FROM ITEMPRODUTO I, PRODUTO P
          WHERE I.CDFILIAL = P_CDFILIAL
            AND I.NRLANCTONF = P_NRLANCTONF
            AND I.CDPRODUTO = P.CDPRODUTO
            AND NOT (P.CDARVPROD LIKE '611%');
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_QTITEMPROD := 0;
      END;

      IF V_QTITEMPROD > 0 THEN
         V_VRDESCFIXO := NVL(ROUND(VALOR_ENCARGO(P_CDFILIAL, P_NRLANCTONF, 'D', '10'),2), 0);
         V_VRDESCDELI := NVL(ROUND(VALOR_ENCARGO(P_CDFILIAL, P_NRLANCTONF, 'D', '06'),2), 0);
         V_VRDESCCOND := NVL(ROUND(VALOR_ENCARGO(P_CDFILIAL, P_NRLANCTONF, 'D', '12'),2), 0);
         V_VRDESCDESV := NVL(ROUND(VALOR_ENCARGO(P_CDFILIAL, P_NRLANCTONF, 'D', '08'),2), 0);
         V_VRDESCITEM := (V_VRDESCFIXO + V_VRDESCDELI + V_VRDESCCOND + V_VRDESCDESV) / V_QTITEMPROD;
      END IF;
   END IF;

   IF P_IDPRODSERV = 'S' THEN
      IF V_QTITEMPROD > 0 THEN
         V_VRDESCFIXO := NVL(ROUND(VALOR_ENCARGO(P_CDFILIAL, P_NRLANCTONF, 'D', '11'),2), 0);
         V_VRDESCDELI := NVL(ROUND(VALOR_ENCARGO(P_CDFILIAL, P_NRLANCTONF, 'D', '07'),2), 0);
         V_VRDESCCOND := NVL(ROUND(VALOR_ENCARGO(P_CDFILIAL, P_NRLANCTONF, 'D', '13'),2), 0);
         V_VRDESCDESV := NVL(ROUND(VALOR_ENCARGO(P_CDFILIAL, P_NRLANCTONF, 'D', '09'),2), 0);
         V_VRDESCITEM := (V_VRDESCFIXO + V_VRDESCDELI + V_VRDESCCOND + V_VRDESCDESV) / V_QTITEMPROD;
      END IF;
   END IF;

   RETURN(NVL(V_VRDESCITEM,0));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_DESCONTO','4.07.283'); END;
/
