<?php
namespace Teknisa\Model\Teknisa\Repositories;


class Sistcontlinp extends \Doctrine\ORM\EntityRepository {
    
    public function findSystemOpenBilling($clientId, $productLineId, $conditions)
    {
        $query = <<<SQL
            SELECT *
              FROM (SELECT SC.CDCLIENTE, SC.CDLINPCLIE, SC.CDSISTEMA,
                           SI.NMSISTEMA, PR.NMPROCOMERCI, SI.IDTECNOSIST, SI.SGSISTEMA
                      FROM SISTCONTLINP SC, SISTEMA SI, PROCOMERCI PR
                     WHERE SC.CDCLIENTE = :P_CDCLIENTE
                       AND SC.CDLINPCLIE = :P_CDLINPCLIE
                       AND SI.CDSISTEMA = SC.CDSISTEMA
                       AND PR.CDPROCOMERCI = SI.CDPROCOMERCI
                  ORDER BY SI.SGSISTEMA)
             WHERE 1 = 1
             $conditions
SQL;
        $params = array('P_CDCLIENTE' => $clientId, 'P_CDLINPCLIE' => $productLineId);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
    public function findSystemReferringToMonth($clientId, $productLineId, $billingMonth, $conditions)
    {
        $query = <<<SQL
            SELECT *
              FROM (SELECT SC.CDCLIENTE, SC.CDLINPCLIE, SC.CDSISTEMA, 
                          SI.NMSISTEMA, PR.NMPROCOMERCI, SI.IDTECNOSIST, SI.SGSISTEMA
                      FROM SISTEMA SI, PROCOMERCI PR, SISTCONTLINPAPU SC
                     WHERE SC.CDCLIENTE = :P_CDCLIENTE
                       AND SC.CDLINPCLIE = :P_CDLINPCLIE
                       AND SC.DTMESAPURLINP = :P_DTMESAPURLINP
                       AND SI.CDSISTEMA = SC.CDSISTEMA
                       AND PR.CDPROCOMERCI = SI.CDPROCOMERCI)
             WHERE 1 = 1
             $conditions
SQL;
        $params = array('P_CDCLIENTE' => $clientId, 'P_CDLINPCLIE' => $productLineId, 'P_DTMESAPURLINP' => $billingMonth);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    
}