import {
  Http, IEventParam, Metadata, IDictionary, I18n,
} from '@zeedhi/core';
import {
  Form, Modal, ModalService, IGridEvent, LoadingService, DialogService, Text, FileInput,
} from '@zeedhi/common';
import { ZdGrid } from '@zeedhi/vuetify';
import { IFieldConditionsParam, CrosstabEditable, ICellConditionsParam } from '@zeedhi/zd-crosstab-common';
import { Utils } from './Utils';

export class Cmp99000GeracaoAfPrevisaoController {
  public filterModal!: Modal;
  
  public filterDetail!: Modal;
  
  public filterDetailCT!: Modal;
  
  public gridDetailModal!: Modal;
  
  public inconsistencyModal!: Modal;
  
  public addForm!: Modal;
  
  public attachment!: Modal;
  
  public deleteForm!: Modal;
  
  public gridEdited!: Modal;
  
  public erroImportar!: Modal;
  
  public gridModalTotalInventoryCost!: Modal;
  
  public dateValue: string | string[] = [];
  
  public dtEntregaValue: string = '';
  
  public dateValueDatail: string | string[] = [];
  
  public filterValueCDFILIOPELOG: any = null;
  
  public filterForm: any = [];
  
  public createForm: any = [];
  
  public del: any = [];
  
  public filters: any = [];
  
  public cdfilialArray: any = [];
  
  public cdFornArray: any = [];
  
  public paraSupri: any = [];
  
  public sessionInfos: any = [];
  
  public dataGrid: any = [];
  
  public filterFromImport: any = [];

  public evento: any = null;
  
  public inconsistencyParams: any = [];
  
  public currentTab: any = 'G';
  
  public cdComprador: any = '';
  
  public cdArvProd: any = '';
  
  public cdFilial: any = '';
  
  public cdTipoCusto: any = '';

  public cdFilCentCmp: any = '';
  
  public nrapurprec: any = '';
  
  public contador: any = '';
  
  public vrcustoest: any = '';
  
  public vrtotalcmp: any = '';
  
  public Utils = new Utils();
  
  public generateParams: any = [];
  
  public createParams: any = [];
  
  public currentRow: any = [];
  
  public rows: any = [];
  
  public createOrGenerate: any = '';
  
  public rowForAnalysis: any = [];
  
  public arraySucesso: any = [];
  
  public editing = false;
  
  public cancelLoad = false;
  
  public fromFilter = true;
  
  public firstLoad = true;
  
  public maskP: string = '';
  
  public desabilitaCentralCMP: Boolean = false;
  
  public modalCloseResolve: (() => void) | null = null;
  
  public async createModals() {
    this.filterModal = await ModalService.createFromJson('pages/cmp99000/cmp99000_filtro', true);
    this.filterDetail = await ModalService.createFromJson('pages/cmp99000/filter_detail', true);
    this.filterDetailCT = await ModalService.createFromJson('pages/cmp99000/filter_details_ct', true);
    this.gridDetailModal = await ModalService.createFromJson('pages/cmp99000/grid_detail', true);
    this.gridModalTotalInventoryCost = await ModalService.createFromJson('pages/cmp99000/grid_total_inventory_cost', true);
    this.inconsistencyModal = await ModalService.createFromJson('pages/cmp99000/inconsistency_grid', true);
    this.addForm = await ModalService.createFromJson('pages/cmp99000/add_form', true);
    this.attachment = await ModalService.createFromJson('pages/cmp99000/add_attachment', true);
    this.erroImportar = await ModalService.createFromJson('pages/cmp99000/erro_importar', true);
    // this.deleteForm = await ModalService.createFromJson('pages/cmp99000/delete_form', true);
    this.gridEdited = await ModalService.createFromJson('pages/cmp99000/grid_edited', true);
    this.filterModal.show();
  }
  
  public async onFilterOpen({ component }: any) {
    this.showLoading('Aguarde...');
    
    const parasupri = Metadata.getInstance<any>('PARASUPRI');
    const paraSupriData = await parasupri.datasource.get();

    this.paraSupri = paraSupriData[0];

    await this.useParaSupri({ component });
  }
  
  public selectChangeD({ component }: IEventParam<any>) {
    if (component.name === 'CDPRODUTOFORMDEL') {
      const fornecedorForm = Metadata.getInstance<any>('CDFORNECEDFORMDEL');
      fornecedorForm.disabled = true;
      fornecedorForm.selectValue = '';
       
      if (component.selectValue != null) {
        fornecedorForm.datasource.filter.P_CDPRODUTO = component.selectValue.CDARVPROD;
        fornecedorForm.disabled = false;
        fornecedorForm.datasource.get().then((success: any) => {
          fornecedorForm.setValue(success[0].CDFORNECED);
        });
      }
    }
  }
  
  public async selectChange({ component }: IEventParam<any>) {
    const nrapurprec = Metadata.getInstance<any>('NRAPURPREC');
    const cdArvProdIni = Metadata.getInstance<any>('CDPRODINI');
    const cdArvProdFin = Metadata.getInstance<any>('CDPRODFIN');
    const cdSubGrupProd = Metadata.getInstance<any>('CDSUBGRUPPROD');
    const promises: Promise<any>[] = [];

    if (component.name === 'CDFILIAL') {
      nrapurprec.datasource.filter.CDFILIAL = 'T';

      if (component.selectValue.length > 0) {
        this.cdfilialArray = this.mountArrayFilter(component.selectValue, 'CDFILIAL');
        nrapurprec.datasource.filter.CDFILIAL = this.cdfilialArray;
      }
      promises.push(nrapurprec.datasource.get());
    }

    if (component.name === 'CDFORNERELACAF') {
      const fornecedor = Metadata.getInstance<any>('CDFORNECED');

      fornecedor.datasource.filter.P_CDFORNERELACAF = 'T';

      if (component.selectValue != null) {
        fornecedor.datasource.filter.P_CDFORNERELACAF = component.selectValue.CDFORNECED;
      }

      promises.push(fornecedor.datasource.get());
    }

    if (component.name === 'CDFORNECED') {
      nrapurprec.datasource.filter.CDFORNECED = 'T';

      if (component.selectValue.length > 0) {
        this.cdFornArray = this.mountArrayFilter(component.selectValue, 'CDFORNECED');
        nrapurprec.datasource.filter.CDFORNECED = this.cdFornArray;
      }

      nrapurprec.disabled = false;

      promises.push(nrapurprec.datasource.get());
    }

    if (component.name === 'CDCOMPRADOR') {
      nrapurprec.disabled = true;
      if (component.selectValue != null) {
        nrapurprec.datasource.filter.CDOPERADOR = component.selectValue.CDOPERADOR;
        nrapurprec.disabled = false;
        promises.push(nrapurprec.datasource.get());
      }
    }

    if (component.name === 'NRAPURPREC') {
      const dtent = Metadata.getInstance<any>('DTENTREGA');
      if (dtent) dtent.addValidation('required');
      if (nrapurprec.selectValue !== null) {
        Metadata.getInstance<any>('DTENTREGA').clearValidations();
      } else {
        this.nrapurprec = null;
      }
      if (nrapurprec && nrapurprec.value && nrapurprec.value != null) {
        // cdArvProdIni.datasource.filter.CDARVPROD = (nrapurprec.value.CDPRODINICAPUR).split('|')[0];
        // cdArvProdFin.datasource.filter.CDARVPROD = (nrapurprec.value.CDPRODFINAAPUR).split('|')[0];
        // cdArvProdIni.datasource.searchIn = '';
        // cdArvProdFin.datasource.searchIn = '';
        promises.push(
          cdArvProdIni.datasource.get().then(() => {
            cdArvProdIni.setValue((nrapurprec.value.CDPRODINICAPUR).split('|')[0]);
          }),
          cdArvProdFin.datasource.get().then(() => {
            cdArvProdFin.setValue((nrapurprec.value.CDPRODFINAAPUR).split('|')[0]);
            cdArvProdIni.datasource.filter = [];
          }),
        );

        const subgrup = cdSubGrupProd.datasource.data.find((subgrupo: any) => {
          if (subgrupo.CDSUBGRPROD === (nrapurprec.value.LISTASUBGRUPO.replace(/_/g, ''))) {
            return subgrupo;
          }
          return null;
        });
        const array = [];
        array.push(subgrup);
        cdSubGrupProd.setValue(array);
      }
    }

    if (component.name === 'CDPRODUTOFORM') {
      const fornecedorForm = Metadata.getInstance<any>('CDFORNECEDFORM');
      fornecedorForm.disabled = true;

      if (component.selectValue != null) {
        fornecedorForm.datasource.filter.P_CDPRODUTO = component.selectValue.CDARVPROD;
        fornecedorForm.disabled = false;
        const vrcustoForm = Metadata.getInstance<any>('VRCUSTOFORM');
        vrcustoForm.value = 0;

        promises.push(
          fornecedorForm.datasource.get().then(() => {
            fornecedorForm.setValue('');
          }),
        );
      }
    }

    if (component.name === 'CDTIPOCUSTO') {
      if (component.selectValue != null) {
        this.cdTipoCusto = component.selectValue.CDTIPOCUSTO;
      }
    }

    if (component.name === 'CDSUBGRUPPROD') {
      const fieldProdIni = Metadata.getInstance<any>('CDPRODINI');
      const fieldProdFin = Metadata.getInstance<any>('CDPRODFIN');

      if (component.selectValue.length > 0) {
        fieldProdIni.clearValidations();
        fieldProdFin.clearValidations();
      } else {
        fieldProdIni.addValidation('required');
        fieldProdFin.addValidation('required');
      }
    }

    if (component.name === 'TIPOPREVISAO') {
      const tabs = Metadata.getInstance<any>('tabsCmp99000');

      tabs.tabs[0].disabled = false;

      Metadata.getInstance<any>('PERIODO').addValidation('required');
      Metadata.getInstance<any>('PERIODO').readonly = false;

      Metadata.getInstance<any>('QTDIAESTOQUE').readonly = false;

      if (component.value.id === 'N') {
        Metadata.getInstance<any>('PERIODO').clearValidations();
        Metadata.getInstance<any>('PERIODO').readonly = true;

        Metadata.getInstance<any>('QTDIAESTOQUE').readonly = true;

        tabs.tabs[0].disabled = false;
      }

      nrapurprec.selectValue = '';
      nrapurprec.datasource.filter.TIPOPREVISAO = component.value.id;
      promises.push(nrapurprec.datasource.get());
    }

    // try {
    //   await Promise.all(promises);
    // } catch (error) {
    //   // console.error('Erro ao executar operações assíncronas:', error);
    // } finally {
    //   if (!this.firstLoad || (this.firstLoad && component.name === 'CDPRODINI')) {
    //     this.hideLoading();
    //     this.firstLoad = false;
    //   }
    // }
  }
  
  public closeFilterModal() {
    this.filterModal.hide();
  }
 
  public async openGridEdited(value: IGridEvent) {
    this.evento = value;
    const instance = Metadata.getInstance<CrosstabEditable>('cmp99000Crosstab');
    const editedRows = instance.getEditedRows();
    if (this.editing && editedRows.length > 0) {
      this.saveGridEdited();
    } else {
      if (this.evento.component.name === 'filterButtonCT') {
        this.openFilterModal(this.evento);
        this.evento = null;
        return;
      }
    
      if (this.evento.component.name === 'GERAAFCT') {
        this.verifyBeforeGenerateCrossTab();
        this.gridEdited.hide();
        this.evento = null;
        return;
      }
    
      if (this.evento.component.name === 'addApurCrossTab') {
        this.openFilterModal(this.evento);
        this.gridEdited.hide();
        this.evento = null;
        return;
      }
    
      if (this.evento.component.name === 'GERAAF') {
        this.verifyBeforeGenerate();
        this.gridEdited.hide();
        this.evento = null;
        return;
      }
      if (this.evento.component.name === 'addCrossTab') {
        this.openFormModal();
        this.gridEdited.hide();
        this.evento = null;
        return;
      }
      if (this.evento.component.name === 'getInfoCT') {
        this.openFilterGetInfo(this.evento);
        this.gridEdited.hide();
        this.evento = null;
      }
    }
  }
 
  public async openFilterModal({ component, event }: IGridEvent) {
    event?.preventDefault();
   
    this.fromFilter = true;
    const textTitle = Metadata.getInstance<Text>('titleFiltro');
    const nrapurprec = Metadata.getInstance<any>('NRAPURPREC');
    if (component.name === 'addApurCrossTab') {
      textTitle.text = 'Adicionar Apuração';
      nrapurprec.setValue(null);
    } else {
      nrapurprec.setValue(nrapurprec.datasource.data[0]);
      textTitle.text = 'Filtro';
    }
    this.filterModal.show();
  }
  
  public async validateForm() {
    const form = Metadata.getInstance<Form>('formFiltro');
    const valid = form.validate();

    if (!valid) {
      this.Utils.alertService('Preencha todos os campos obrigatórios!', 'error');

      return;
    }
    
    this.filterForm = form;
    
    if (this.filterForm.internalValue.CDPRODINI && this.filterForm.internalValue.CDPRODFIN) {
      if (String(this.filterForm.internalValue.CDPRODINI.CDARVPROD) > String(this.filterForm.internalValue.CDPRODFIN.CDARVPROD)) {
        this.Utils.alertService('O Produto Final, tem que ser maior do que o Produto Inicial.', 'error');
  
        return;
      }
    }
    
    setTimeout(() => {
      const tabs = Metadata.getInstance<any>('tabsCmp99000');
      
      tabs.nextTab();
  
      this.currentTab = 'C';
    
      this.loadGrid().then(() => {
        this.closeFilterModal();
      });
    }, 1000);
  }
  
  public getFilters() {
    this.filterForm = Metadata.getInstance<Form>('formFiltro');
    const filterForm = this.filterForm.internalValue;
    this.cdComprador = filterForm.CDCOMPRADOR.CDOPERADOR;

    const baseParams = {
      CDFORNERELACAF: filterForm.CDFORNERELACAF != null ? filterForm.CDFORNERELACAF.CDFORNECED : 'T',
      CDFORNECED: filterForm.CDFORNECED.length > 0 ? this.mountArrayFilter(filterForm.CDFORNECED, 'CDFORNECED') : 'T',
      CDCOMPRADOR: filterForm.CDCOMPRADOR.CDOPERADOR ?? null,
      TIPOPREVISAO: filterForm.TIPOPREVISAO.id ?? null,
      CDSUBGRUPPROD: filterForm.CDSUBGRUPPROD.length > 0 ? this.mountArrayFilterSubGroup(filterForm.CDSUBGRUPPROD) : 'T',
      CDMARCA: filterForm.CDMARCA.length > 0 ? this.mountArrayFilter(filterForm.CDMARCA, 'CDMARCA') : 'T',
      DTINICIAL: filterForm.PERIODO.length > 0 ? filterForm.PERIODO[0] : filterForm.DTENTREGA,
      DTFINAL: filterForm.PERIODO.length > 0 ? filterForm.PERIODO[1] : filterForm.DTENTREGA,
      QTDIAESTOQUE: filterForm.QTDIAESTOQUE != null ? filterForm.QTDIAESTOQUE : null,
      DTENTREGA: filterForm.DTENTREGA,
      CDTIPOCUSTO: filterForm.CDTIPOCUSTO != null ? filterForm.CDTIPOCUSTO.CDTIPOCUSTO : '',
      CDFILCENTCMP: this.paraSupri != null ? this.paraSupri.CDFILCENTCMP : '',
      NRORG: this.paraSupri != null ? this.paraSupri.NRORG : '',
      TIPOTELA: this.currentTab,
      UM_REGISTRO: '',
      VRCUSTO: null,
      QTSOLIPROD: null,
      CDOPERADOR: null,
    };

    const additionalParams = this.arraySucesso.length === 0
      ? {
        CDPRODINI: filterForm.CDPRODINI != null ? filterForm.CDPRODINI.CDARVPROD : 0,
        CDPRODFIN: filterForm.CDPRODFIN != null ? filterForm.CDPRODFIN.CDARVPROD : 'Z',
        CDFILIAL: filterForm.CDFILIAL.length > 0 ? this.mountArrayFilter(filterForm.CDFILIAL, 'CDFILIAL') : 'T',
        NRAPURPREC: filterForm.NRAPURPREC != null ? filterForm.NRAPURPREC.NRAPURPREC : '',
      }
      : {
        CDPRODINI: this.filterFromImport.CDPRODINI != null ? this.filterFromImport.CDPRODINI : 0,
        CDPRODFIN: this.filterFromImport.CDPRODFIN != null ? this.filterFromImport.CDPRODFIN : 'Z',
        CDFILIAL: this.filterFromImport.CDFILIAL != null ? this.filterFromImport.CDFILIAL : 'T',
        NRAPURPREC: '',
      };

    return { ...baseParams, ...additionalParams };
  }

  public mountArrayFilter(items: any, fieldName: any) {
    const newArray: Array<any> = [];

    if (items) {
      items.forEach((item: any) => {
        newArray.push(item[fieldName]);
      });
    }
    
    if (newArray.toString() !== 'underfined' && newArray.toString() !== null && newArray.toString() !== '') {
      const concactedArray = newArray.toString().replaceAll(',', '_');
      
      return String('_').concat(concactedArray.concat(String('_')));
    }
    
    return null;
  }
  
  public mountArrayFilterSubGroup(items: any) {
    const newArray: Array<any> = [];

    if (items) {
      items.forEach((item: any) => {
        if (item instanceof Object) {
          newArray.push(item.CDSUBGRPROD);
        } else {
          newArray.push(item);
        }
      });
    }
    
    if (newArray.toString() !== 'underfined' && newArray.toString() !== null && newArray.toString() !== '') {
      const concactedArray = newArray.toString().replaceAll(',', '_');
      
      return String('_').concat(concactedArray.concat(String('_')));
    }
    
    return null;
  }
  
  public async loadGrid() {
    this.filters = this.getFilters();
    const filters = this.filters;
    // const filtro = Metadata.getInstance<any>('NRAPURPREC');
    const nrapurprec = Metadata.getInstance<any>('NRAPURPREC');
    this.showLoading('Buscando Apuração...');
    
    // await filtro.datasource.get().then((success: any) => {
    //   const elementoEncontrado = success[0].NRAPURPREC === this.nrapurprec && filters.NRAPURPREC === '';
    //   if (elementoEncontrado) {
    //     filters.NRAPURPREC = success[0].NRAPURPREC;
    //   } else {
    //     this.nrapurprec = null;
    //   }
    // });
    
    const grid = Metadata.getInstance<any>('cmp99000Grid');
    const title = Metadata.getInstance<any>('cmp99000Grid_gridTitle');

    title.text = 'Geração de AF por Previsão de Compra';
    grid.addButton = false;
    grid.selectedRows = [];
    
    try {
      if (this.fromFilter && filters.NRAPURPREC === '' && filters.TIPOPREVISAO !== 'N') {
        await this.verifyBeforeGenerateFilter(filters);
      } else {
        await Http.get('/getGeracaoAfPrevisao', { params: { filters } }).then((response) => {
          this.dataGrid = response.data.dataset.data;
         
          if (response.data.dataset.data.length > 0) {
            // response.data.dataset.data.forEach((elemento: any )=> {
            //   elemento.CDARVPROD = this.applyMask(elemento.CDARVPROD);
            // });
            nrapurprec.setValue(response.data.dataset.data[0].NRAPURPREC);
            this.rowForAnalysis = response.data.dataset.data[0];
            this.contador = response.data.dataset.data[0].CONTADOR;
            this.nrapurprec = response.data.dataset.data[0].NRAPURPREC;
            this.vrtotalcmp = response.data.dataset.data[0].VRTOTALCMP;
            this.vrcustoest = response.data.dataset.data[0].VRTOTALEST;

            if (this.currentTab === 'G') {
              grid.datasource.updateData(response.data.dataset.data).then(() => {
                this.closeFilterModal();
              });
            }
         
            if (this.currentTab === 'C') {
              const crossTab = Metadata.getInstance<any>('cmp99000Crosstab');
              
              crossTab.datasource.post([]);
              
              this.currentRow = response.data.dataset.data[0];
              
              this.currentRow.CDMARCA = this.paraSupri.CDMARCA;
              
              this.newCrossTab(response.data.dataset.data);
            }
          
            if (this.nrapurprec != null && title) {
              title.text = String('Geração de AF por Previsão de Compra N°').concat(String(this.nrapurprec));
            }
          } else {
            if (this.currentTab === 'G') {
              grid.datasource.updateData(response.data.dataset.data).then(() => {
                this.hideLoading();
                this.closeFilterModal();
              });
            }
         
            if (this.currentTab === 'C') {
              const crossTab = Metadata.getInstance<any>('cmp99000Crosstab');
             
              crossTab.datasource.post([]);
              
              this.newCrossTab(response.data.dataset.data);
            }
          }
        });
        this.firstLoad = false;
        if (this.modalCloseResolve) {
          this.modalCloseResolve();
          this.modalCloseResolve = null; // Reset the resolve function
        }
      }
      setTimeout(() => {
        this.hideLoading();
      }, 1600);
    } catch (error) {
      this.Utils.alertService('Não há dados', 'error');
      
      this.hideLoading();
      this.closeModalErroImport();
      this.closeModalAttachment();
      this.closeFilterModal();
    }
  }
  
  public closeGridModalTotalInventoryCost() {
    this.gridModalTotalInventoryCost.hide();
  }
  
  public async showGridModalTotalInventoryCost() {
    await this.gridModalTotalInventoryCost.show();
    const filters = this.getFilters();
    filters.UM_REGISTRO = 'SN';
    Http.get('/getGeracaoAfPrevisao', { params: { filters } }).then((response) => {
      const data = response.data.dataset.data;
      // const dataProduct : any = [];
      const gridUnit = Metadata.getInstance<any>('gridTotalInventoryUnit');
      // const gridProduct = Metadata.getInstance<any>('gridTotalInventoryProduct');
      gridUnit.datasource.updateData(data);
      gridUnit.rowClick(data[0]);
    });
  }
  
  public async getProduct(row :any) {
    const filters = this.getFilters();
    filters.CDFILIAL = `_${row.row.CDFILSOLI}_`;
    filters.UM_REGISTRO = 'NS';
    filters.TIPOTELA = 'G';
    Http.get('/getGeracaoAfPrevisao', { params: { filters } }).then((response) => {
      const data = response.data.dataset.data;
      const gridProduct = Metadata.getInstance<any>('gridTotalInventoryProduct');
      gridProduct.datasource.updateData(data);
    });
  }
  
  public async newCrossTab(dataGrid: any) {
    const crossTab = Metadata.getInstance<CrosstabEditable>('cmp99000Crosstab');
    const subtitle = Metadata.getInstance<any>('subtitleCrossTab');
    const title = Metadata.getInstance<any>('crossTabCardTitle');
    const est = Metadata.getInstance<any>('VRCUSTOESTCard');
    const cmp = Metadata.getInstance<any>('VRTOTALCMPCard');

    subtitle.isVisible = false;
    title.title = 'Geração de AF por Previsão de Compra';
    
    const formattedData = await this.formatCrossTab(dataGrid);
    
    await crossTab.datasource.updateData(formattedData);
    
    if (this.vrcustoest != null) {
      est.children[0].text = 'Vr. Total Custo Est: '.concat(String(this.vrcustoest));
    } else {
      est.visible = false;
    }
    
    if (this.vrtotalcmp != null) {
      cmp.children[0].text = 'Vr. Total CMP: '.concat(String(this.vrtotalcmp));
    } else {
      cmp.visible = false;
    }
    if (this.nrapurprec != null && this.contador != null) {
      title.title = String('Geração de AF por Previsão de Compra N°').concat(String(this.nrapurprec)).concat(' com Total de Itens igual a  ').concat(String(this.contador));
      subtitle.isVisible = true;
    } else if (this.nrapurprec != null) {
      title.title = String('Geração de AF por Previsão de Compra N°').concat(String(this.nrapurprec));
      subtitle.isVisible = true;
    }
    // this.hideLoading();
    this.evento = null;
  }

  public async useParaSupri({ component }: any) {
    const subgroup = Metadata.getInstance<any>('CDSUBGRUPPROD');
    const nrapurprec = Metadata.getInstance<any>('NRAPURPREC');
    const cdfilial = Metadata.getInstance<any>('CDFILIAL');
    const cdcomprador = Metadata.getInstance<any>('CDCOMPRADOR');
    const cdmarca = Metadata.getInstance<any>('CDMARCA');
    const cdtipocusto = Metadata.getInstance<any>('CDTIPOCUSTO');
    const tabs = Metadata.getInstance<any>('tabsCmp99000');
    
    Promise.all([
      cdtipocusto.datasource.get(),
      cdmarca.datasource.get(),
      cdfilial.datasource.get(),
      cdcomprador.datasource.get(),
    ]).then(() => {
      Http.get('/getSessionInfos').then((response) => {
        const dtnow = (new Date().getMonth() + 1).toString().concat('/') + new Date().getFullYear().toString();
    
        this.dateValue = [
          dtnow,
          dtnow,
        ];
        
        const now = new Date();
        const dtentrnow = now.toLocaleDateString();
        
        this.dtEntregaValue = dtentrnow;
        
        if (typeof this.paraSupri !== 'undefined' && typeof this.paraSupri !== null) {
          subgroup.datasource.filter.P_CDGRUPPROD = this.paraSupri.CDGRUPPROD;
          nrapurprec.datasource.filter.CDFILCENTCMP = this.paraSupri.CDFILCENTCMP;
          cdfilial.datasource.filter.P_CDFILCENTCMP = this.paraSupri.CDFILCENTCMP;
          
          this.cdFilCentCmp = this.paraSupri.CDFILCENTCMP;
          cdmarca.setValue([this.paraSupri.CDMARCA]);
          
          subgroup.datasource.get().then((response1: any) => {
            subgroup.updateData(response1);
          });
        }
        
        this.sessionInfos = response.data.dataset.data;
        
        if (this.sessionInfos.CDFILIAL !== this.paraSupri.CDFILCENTCMP) {
          cdfilial.readonly = true;
          cdfilial.setValue([this.sessionInfos.CDFILIAL]);
        } else {
          cdfilial.readonly = false;
        }
        
        cdcomprador.setValue(this.sessionInfos.CDOPERADOR);
        cdtipocusto.setValue(cdtipocusto.datasource.data[0]);
        
        this.cdTipoCusto = cdtipocusto.datasource.data[0];
  
        nrapurprec.datasource.filter.CDOPERADOR = this.sessionInfos.CDOPERADOR;
        if (nrapurprec.disabled === true) {
          if (component.parent.children[0].leftSlot[0].text === 'Filtro') {
            nrapurprec.datasource.get().then((success: any) => {
              nrapurprec.setValue(success[0]);
              if (nrapurprec.datasource.filter.TIPOPREVISAO === 'N') {
                tabs.tabs[0].disabled = true;
                Metadata.getInstance<any>('PERIODO').clearValidations();
                Metadata.getInstance<any>('PERIODO').readonly = true;
                Metadata.getInstance<any>('QTDIAESTOQUE').readonly = true;
              } else {
                tabs.tabs[0].disabled = false;
                Metadata.getInstance<any>('PERIODO').readonly = false;
                Metadata.getInstance<any>('PERIODO').addValidation('required');
                Metadata.getInstance<any>('QTDIAESTOQUE').readonly = false;
              }
            });
          }
        }
        
        this.hideLoading();
      });
    });
  }
  
  public showFirstLoading() {
    this.showLoading('Carregando Dados...');
    this.getMask();
  }
  
  public async saveUpdates({ component, event }: any) {
    event?.preventDefault();
    
    this.showLoading('Atualizando dados...');
    try {
      await Http.post('/updateProducts', component.editedRows).then((response) => {
        if (response.data.dataset.data.success === true) {
          this.Utils.alertService('Produtos atualizados com sucesso.', 'success');
        }
        this.loadGrid();
        this.hideLoading();
      });
    } catch (error) {
      this.Utils.alertService('Erro ao atualizar.', 'error');
      this.loadGrid();
      this.hideLoading();
    }
  }
  
  public cancelUpdates() {
    this.loadGrid();
  }
  
  public changeTab({ event }: any) {
    if (event === 2) {
      return;
    }
    const tabs: any = {
      0: 'G',
      1: 'C',
    };

    this.currentTab = tabs[event];
   
    this.loadGrid();
  }
  
  public async verifyBeforeGenerate() {
    const grid = Metadata.getInstance<ZdGrid>('cmp99000Grid');
    
    this.generateParams = {
      rows: grid.selectedRows,
      CDOPERADOR: this.cdComprador,
    };

    if (grid.selectedRows.length <= 0) {
      this.Utils.alertService('Selecione algum produto para a Geração de AF!', 'error');
        
      return;
    }
    
    if (this.validateSelectedRows(grid.selectedRows) > 0) {
      this.Utils.alertService('Não é possível confirmar operação para item com Quantidade ou Preço Unitário igual a zero(0).', 'error');
      
      return;
    }
    
    const params = {
      rows: grid.selectedRows,
      CDOPERADOR: this.cdComprador,
      filters: this.filters,
    };
    
    this.createOrGenerate = 'generate';
    this.validateItem(params);
  }

  // public fornBlur({ component, element }: any) {
  //   // const value = Metadata.getInstance<any>('CDFORNECED');
  //   // value.datasource.loadAll = true;
  //   // value.datasource.get().then((success: any) => {});
  // }
  
  public async verifyBeforeGenerateEdited(rows : any) {
    if (rows.length <= 0) {
      this.Utils.alertService('Selecione algum produto para a Geração de AF!', 'error');
      return;
    }
    const value = Metadata.getInstance<any>('CDFORNECED');
    
    const row = rows.filter((item: any) => item.DSTIPO !== 'EST');
    const r: Array<any> = [];
    value.datasource.loadAll = true;
    await value.datasource.get().then((success: any) => {
      row.forEach((item: any) => {
        if (item.NRINSJURFORN && item.NRINSJURFORN.split(' ').length === 1) {
          if (item.VRCUSTO === '0') {
            this.Utils.alertService('Preço unitário pecisa ser maior que zero(0) para salvar o fornecedor informado.', 'error');
            // c=false;
            return;
          }

          const v = success.find((x : any) => x.CDFORNECED === item.CDFORNECED_OLD);
          if (item.NRINSJURFORN && (item.CDFORNECED === null || item.CDFORNECED_OLD === '' || v.NRINSJURFORN !== item.NRINSJURFORN.split(' ', 1)[0])) {
            const forneced = success.find((x : any) => x.NRINSJURFORN === item.NRINSJURFORN.split(' ', 1)[0] || x.CDEXFORNECED === item.NRINSJURFORN);
            if (forneced !== undefined) {
              item.CDFORNECED = forneced.CDFORNECED;
              r.push(item);
              return;
            }
          }
          this.Utils.alertService('Fornecedor informado não encontrado.', 'error');
          item.VRCUSTO = '0';
          return;
        }
        if (item.NRINSJURFORN && item.VRCUSTO !== '0' && item.NRINSJURFORN.split(' ').length === 0) {
          item.VRCUSTO = '0';
          this.Utils.alertService('Precisa existir fornecedor para salvar valor unitário.', 'error');
        } else {
          r.push(item);
        }
      });
    });
    
    //  if (row[0].CDFORNECED != null) {
    // if (this.validateSelectedRows(row) > 0) {
    //    this.Utils.alertService('Não é possível gerar AF para item com Quantidade ou Preço Unitário igual a zero(0).', 'error');
    //    return;
    //  }
    // if(!c){
    //   return;
    // }
    if (r.length > 0) {
      const params = {
        rows: r,
        CDOPERADOR: this.cdComprador,
        filters: this.filters,
        edit: true,
      };
  
      this.createOrGenerate = 'generate';
      if (this.arraySucesso.length === 0) {
        this.validateItemEdit(params).then(() => {
      
        });
      } else {
        this.saveEdited(params);
        this.arraySucesso = [];
      }
    //  } else {
    //  const params = {
    //    rows: row,
    //    CDOPERADOR: this.cdComprador,
    //    filters: this.filters,
    //  };
    //  this.createOrGenerate = 'generate';
    //  this.validateBeforecreateSave(params);
    //  // this.validateItemEdit(params);
    //  }
    }
  }
  
  public async verifyBeforeGenerateCrossTab() {
    this.showLoading('Gerando AF, aguarde...');
    const crossTab = Metadata.getInstance<CrosstabEditable>('cmp99000Crosstab');
    
    const onlyCMPRows = await crossTab.datasource.data.filter((row) => row.DSTIPO === 'CMP');
    
    if (this.validateSelectedRows(onlyCMPRows) > 0) {
      this.Utils.alertService('Item(s) com Quantidade ou Preço Unitário igual a zero não serão gerados!', 'warning');
    }
    
    const onlyFilledRows = await onlyCMPRows.filter((row) => row.VRCUSTOBKP > 0 && row.QTSOLIPROD > 0);
    
    const params = {
      rows: onlyFilledRows,
      CDOPERADOR: this.cdComprador,
      filters: this.filters,
      edit: true,
      geraAf: 'S',
    };
    
    this.generateParams = {
      rows: onlyFilledRows,
      CDOPERADOR: this.cdComprador,
    };
    
    this.createOrGenerate = 'generateCrossTab';
    this.validateItem(params);
  }
  
  public async verifyBeforeGenerateFilter(filter: any) {
    filter.TIPOTELA = 'C';
    const params = {
      CDOPERADOR: this.cdComprador,
      filters: filter,
    };
   
    this.createOrGenerate = 'filter';
    await this.validateItem(params);
    return true;
  }
  
  public getMask() {
    if (this.maskP === '') {
      Http.get('/getMask').then((response) => {
        this.maskP = response.data.dataset.data[0].CDPICTPROD;
        // this.maskP = this.productMask(value, response.data.dataset.data[0]['CDPICTPROD']);
      });
    }
  // else {
  //   return  this.productMask(value, this.maskP);
  // }
  }
  
  public up({ component, element }: IEventParam<CrosstabEditable>) {
    component.navigateUp();
    this.verticalScroll(element);
  }

  public down({ component, element }: IEventParam<CrosstabEditable>) {
    component.navigateDown();
    this.verticalScroll(element);
  }

  public left({ component, element }: IEventParam<CrosstabEditable>) {
    component.navigateLeft();
    this.horizontalScroll(element);
  }

  public right({ component, element }: IEventParam<CrosstabEditable>) {
    // Primeira chamada para navegar para a direita
    component.navigateRight();
  
    // Atualiza o elemento ativo após a navegação
    const { activeElement } = document;
  
    // Verifica se o novo elemento ativo é um <th> e tem data-col-index igual a 0
    if (activeElement?.tagName === 'TH' && activeElement.getAttribute('data-col-index') === '0') {
      // Se verdadeiro, navega para a direita novamente
      component.navigateRight();
    }
  
    // Chamada para ajustar o scroll horizontal
    this.horizontalScroll(element);
  }
  
  getActiveCell(crosstabElement: HTMLElement) {
    const { activeElement } = document;
  
    if (activeElement instanceof HTMLInputElement) {
      return crosstabElement.querySelector('zd-cross-tab-field--is-current, zd-cross-tab-cell--is-current');
    }
  
    return activeElement;
  }
  
  horizontalScroll(crosstabElement: HTMLElement) {
    const activeElement = this.getActiveCell(crosstabElement);
    const th = activeElement?.parentElement?.querySelector('th:last-of-type');
  
    if (!th || !activeElement) return;
  
    if (this.isOverlapping(activeElement, th)) {
      const rect1 = activeElement.getBoundingClientRect();
      const rect2 = th.getBoundingClientRect();
  
      crosstabElement.scrollLeft -= rect2.right - rect1.left;
    }
  }
  
  verticalScroll(crosstabElement: HTMLElement) {
    const activeElement = this.getActiveCell(crosstabElement);
    if (!activeElement) return;
    const head = crosstabElement.querySelector('thead');
    const lastTr = head?.querySelector('tr:last-of-type');
    const th = lastTr?.querySelector('th');
  
    if (!th) return;
  
    if (this.isOverlappingVertical(th, activeElement)) {
      const rect1 = activeElement.getBoundingClientRect();
      const rect2 = th.getBoundingClientRect();
  
      crosstabElement.scrollTop -= rect2.bottom - rect1.top;
    }
  }
  
  public isOverlapping(elem1: Element, elem2: Element) {
    const rect1 = elem1.getBoundingClientRect();
    const rect2 = elem2.getBoundingClientRect();
  
    return !(
      rect1.right < rect2.left
      || rect1.left > rect2.right
      || rect1.bottom < rect2.top
      || rect1.top > rect2.bottom
    );
  }
  
  public isOverlappingVertical(elem1: Element, elem2: Element) {
    const rect1 = elem1.getBoundingClientRect();
    const rect2 = elem2.getBoundingClientRect();
  
    return !(
      rect1.bottom < rect2.top
      || rect1.top > rect2.bottom
    );
  }
  
  public async generateAfs() {
    this.closeInconsistencyModal();
    
    const params = this.generateParams;
    
    try {
      await Http.post('/generateAfs', params).then((response) => {
        this.showGenerateAfAlert(response.data.dataset.data.erroGeral);
        
        this.hideLoading();
      });
    } catch (error) {
      this.Utils.alertService('Erro inesperado, consulte o administrador de sistema', 'error');
      
      this.loadGrid();
      this.hideLoading();
    }
  }
  
  public async generateAfsCrossTab() {
    this.closeInconsistencyModal();
    
    const params = this.generateParams;
    
    if (params.rows.length > 0) {
      try {
        await Http.post('/generateAfs', params).then((response) => {
          this.showGenerateAfAlert(response.data.dataset.data.erroGeral);
          
          this.hideLoading();
        });
      } catch (error) {
        this.Utils.alertService('Erro inesperado, consulte o administrador de sistema', 'error');
        this.loadGrid();
        this.hideLoading();
      }
    } else {
      this.Utils.alertService('Não há dados para geração de AF.', 'error');
      
      this.loadGrid();
      this.hideLoading();
    }
  }
  
  public async showGenerateAfAlert(error: any) {
    if (error === 'R') {
      this.Utils.alertService('Não foi possível efetivar a compra, pois existe(m) AF(s) inconsistente(s) ou fora do limite.', 'error');
    }
           
    if (error === 'S') {
      this.Utils.alertService('Existe(m) AF(s) inconsistente(s) ou fora do limite, Para visualizá-las verifique o relatório AFs Inconsistentes/Fora do Limite na tela Análise de Autorização de Fornecimento.', 'error');
    }
      
    if (error === 'N') {
      this.Utils.alertService('AF Gerado com sucesso', 'success');
    }
    
    if (error === 'A') {
      this.Utils.alertService('Não há dados para geração de AF.', 'error');
    }
    
    this.hideLoading();
    this.showDialog();
  }
  
  public validateSelectedRows(rows: any): any {
    let invalidRows: number = 0;
    
    rows.forEach((row: any) => {
      if (row.VRCUSTO <= 0 || row.QTSOLIPROD <= 0) {
        invalidRows += 1;
      }
    });

    return invalidRows;
  }
  
  public formatCrossTab(data: any): any {
    const formatedData: Array<any> = [];
    let cont = 0;
    
    data.forEach((row: any) => {
      row.CONT = cont;
      
      row.ID += row.DSTIPO;
      
      if (row.VRPRECUNIAP > 0) {
        row.VRPRECUNIAP = row.VRPRECUNIAP.toFixed(3).toString().replace('.', ',');
      } else {
        row.VRPRECUNIAP = '0';
      }
      
      if (row.VRCUSTO > 0) {
        row.VRCUSTOBKP = row.VRCUSTO;
        row.VRCUSTO = row.VRCUSTO.toFixed(3).toString().replace('.', ',');
      } else {
        row.VRCUSTO = '0';
      }
      
      formatedData.push(row);
      
      cont += 1;
    });
    
    return formatedData;
  }
  
  public formatter(value: any) {
    if (value === null) {
      return '';
    }
    
    return value;
  }
  
  public showLoading(message: string) {
    LoadingService.show(message);
  }
  
  public hideLoading() {
    LoadingService.hide();
  }
  
  public showFilterDetail({ event }: IGridEvent) {
    event?.preventDefault();
    if (this.currentTab === 'G') {
      this.filterDetail.show();
    } else {
      this.filterDetailCT.show();
    }
  }
  
  public getPeriod({ component } : any) {
    const date = new Date();
    const date1 = new Date();
    date1.setMonth(date.getMonth() - 4);
    let period;
    if (component.name === 'filterDetailFormCT') {
      period = Metadata.getInstance<any>('PERIODODETAILCT');
    } else if (component.name === 'filterDetailForm') {
      period = Metadata.getInstance<any>('PERIODODETAIL');
    } else {
      period = component;
    }
    period.value = [
      date1.toLocaleDateString(),
      date.toLocaleDateString(),
    ];
  }
  
  public setRowInfo({ row }: any) {
    this.cdArvProd = row.CDARVPROD;
    this.cdFilial = row.CDFILLAN;
    this.currentRow = row;
    
    const grid = Metadata.getInstance<any>('cmp99000Grid');
   
    grid.addButton = true;
  }
  
  public closeFilterDetail() {
    this.filterDetail.hide();
  }
  
  public closeFilterDetailCT() {
    this.filterDetailCT.hide();
  }
  
  public async getDetails() {
    if (this.currentTab === 'G') {
      const form = Metadata.getInstance<any>('filterDetailForm');
      const valid = form.validate();
  
      if (!valid) {
        this.Utils.alertService('Preencha todos os campos obrigatórios!', 'error');
      } else {
        const filters = {
          CDARVPROD: this.cdArvProd,
          CDFILIAL: this.currentRow.CDFILSOLI,
          CDMARCA: this.currentRow.CDMARCA,
          DTINICIAL: form.internalValue.PERIODODETAIL[0],
          DTFINAL: form.internalValue.PERIODODETAIL[1],
          TIPO: form.value.TYPEDETAIL.id,
        };
        
        this.showLoading('Buscando Produto...');
        
        try {
          await Http.get('/getDetails', { params: { filters } }).then((response) => {
            if (response.data.dataset.data.length > 0) {
              this.filterDetail.hide();
              this.gridDetailModal.show();
            
              setTimeout(() => {
                const gridDetail = Metadata.getInstance<any>('gridDetail');
                const fornColumn = gridDetail.getColumn('DSDESTINATARIO');
                const marcaColumn = gridDetail.getColumn('DSMARCA');
                const nrsec = gridDetail.getColumn('NRSEQUENCIAL');
                const entregaColumn = gridDetail.getColumn('DTENTREGA');

                fornColumn.label = 'Cliente';
                marcaColumn.isVisible = false;
                  
                if (form.internalValue.TYPEDETAIL.id === 'AF' || form.internalValue.TYPEDETAIL.id === 'NF') {
                  fornColumn.label = 'Fornecedor';
                  
                  if (form.internalValue.TYPEDETAIL.id === 'AF') {
                    marcaColumn.isVisible = true;
                  }
                }
                if (!form.internalValue.TYPEDETAILCT) {
                  form.internalValue.TYPEDETAILCT = form.internalValue.TYPEDETAIL;
                }
                if (form.internalValue.TYPEDETAILCT.id === 'AF') {
                  entregaColumn.label = 'Entrega';
                  nrsec.label = 'Unidade/Nº AF';
                }
                if (form.internalValue.TYPEDETAILCT.id === 'NF') {
                  entregaColumn.label = 'Dt. Entrada';
                  nrsec.label = 'Unidade/Nº NF';
                }
                if (form.internalValue.TYPEDETAILCT.id === 'PE') {
                  entregaColumn.label = 'Entrega';
                  nrsec.label = 'Unidade/Nº Pedido Tipo';
                }
                if (form.internalValue.TYPEDETAILCT.id === 'RE') {
                  entregaColumn.label = 'Dt. Saída';
                  nrsec.label = 'Unidade/Nº Lanç.';
                }
                
                gridDetail.datasource.updateData(response.data.dataset.data);
                
                if (response.data.dataset.data.length > 0) {
                  this.getTaxes(response.data.dataset.data[0]);
                } else {
                  const taxesGrid = Metadata.getInstance<ZdGrid>('taxesDetail');
                  
                  taxesGrid.datasource.updateData([]);
                }
                
                this.hideLoading();
              }, 1000);
            } else {
              this.Utils.alertService('Não há dados', 'warning');
              
              this.hideLoading();
            }
          }).catch((error) => {
            this.Utils.alertService(error, 'error');
            this.hideLoading();
          });
        } catch (error) {
          this.Utils.alertService(error, 'error');
          this.hideLoading();
        }
      }
    } else {
      const form = Metadata.getInstance<any>('filterDetailFormCT');
      const valid = form.validate();
      
      if (!valid) {
        this.Utils.alertService('Preencha todos os campos obrigatórios!', 'error');
      } else {
        let v = '_';
        form.value.CDFILIALFORMCT.forEach((x: any) => {
          v = v.concat(x.CDFILIAL).concat('_');
        });
        
        const filters = {
          CDARVPROD: form.value.CDPRODUTOFORMCT.CDARVPROD,
          CDFILIAL: v,
          CDMARCA: form.value.CDMARCAFORMCT.CDMARCA,
          DTINICIAL: form.internalValue.PERIODODETAILCT[0],
          DTFINAL: form.internalValue.PERIODODETAILCT[1],
          TIPO: form.value.TYPEDETAILCT.id,
        };
        
        this.showLoading('Buscando Produto...');
        try {
          await Http.get('/getDetails', { params: { filters } }).then((response) => {
            if (response.data.dataset.data.length > 0) {
              this.filterDetailCT.hide();
              
              this.gridDetailModal.show();
              
              setTimeout(() => {
                const gridDetail = Metadata.getInstance<any>('gridDetail');
                const fornColumn = gridDetail.getColumn('DSDESTINATARIO');
                const nrsec = gridDetail.getColumn('NRSEQUENCIAL');
                const marcaColumn = gridDetail.getColumn('DSMARCA');
                const entregaColumn = gridDetail.getColumn('DTENTREGA');
                
                fornColumn.label = 'Cliente';
                marcaColumn.isVisible = false;
                if (form.value.TYPEDETAILCT.id === 'AF') {
                  entregaColumn.label = 'Entrega';
                  nrsec.label = 'Unidade/Nº AF';
                }
                if (form.value.TYPEDETAILCT.id === 'NF') {
                  entregaColumn.label = 'Dt. Entrada';
                  nrsec.label = 'Unidade/Nº NF';
                }
                if (form.value.TYPEDETAILCT.id === 'PE') {
                  entregaColumn.label = 'Entrega';
                  nrsec.label = 'Unidade/Nº Pedido Tipo';
                }
                if (form.value.TYPEDETAILCT.id === 'RE') {
                  entregaColumn.label = 'Dt. Saída';
                  nrsec.label = 'Unidade/Nº Lanç.';
                }
                  
                if (form.value.TYPEDETAILCT.id === 'AF' || form.value.TYPEDETAILCT.id === 'NF') {
                  fornColumn.label = 'Fornecedor';
                  
                  if (form.value.TYPEDETAILCT.id === 'AF') {
                    marcaColumn.isVisible = true;
                  }
                }
                
                gridDetail.datasource.updateData(response.data.dataset.data);
                
                if (response.data.dataset.data.length > 0) {
                  this.getTaxes(response.data.dataset.data[0]);
                } else {
                  const taxesGrid = Metadata.getInstance<ZdGrid>('taxesDetail');
                  
                  taxesGrid.datasource.updateData([]);
                }
            
                this.hideLoading();
              }, 1000);
            } else {
              this.Utils.alertService('Não há dados', 'warning');
              
              this.hideLoading();
            }
          }).catch((error) => {
            this.Utils.alertService(error, 'error');
            this.hideLoading();
          });
        } catch (error) {
          this.Utils.alertService(error, 'error');
          this.hideLoading();
        }
      }
    }
  }
  
  public getTaxesFromJson({ row }: any) {
    this.getTaxes(row);
  }
  
  public async getTaxes(row :any) {
    if (this.currentTab === 'G') {
      const form = Metadata.getInstance<any>('filterDetailForm');
    
      const filters = {
        CDARVPROD: row.CDARVPROD,
        CDFILIAL: this.currentRow.CDFILSOLI,
        NRSEQUENCIAL: row.CHAVE,
        DTENTREGA: row.DTENTREGA,
        CDMARCA: row.CDMARCA,
        TIPO: form.internalValue.TYPEDETAIL.id,
      };
      
      this.showLoading('Buscando Produto...');
      
      try {
        await Http.get('/getTaxesDetails', { params: { filters } }).then((response) => {
          this.gridDetailModal.show();
          const taxesGrid = Metadata.getInstance<ZdGrid>('taxesDetail');
             
          taxesGrid.datasource.updateData(response.data.dataset.data);
        });
          
        this.hideLoading();
      } catch (error) {
        this.Utils.alertService(error, 'error');
        this.hideLoading();
      }
    } else {
      const form = Metadata.getInstance<any>('filterDetailFormCT');
    
      const filters = {
        CDARVPROD: row.CDARVPROD,
        CDFILIAL: form.value.CDFILIALFORMCT.CDFILIAL,
        NRSEQUENCIAL: row.CHAVE,
        DTENTREGA: row.DTENTREGA,
        CDMARCA: row.CDMARCA,
        TIPO: form.value.TYPEDETAILCT.id,
      };
      
      this.showLoading('Buscando Produto...');
      
      try {
        await Http.get('/getTaxesDetails', { params: { filters } }).then((response) => {
          this.gridDetailModal.show();
          const taxesGrid = Metadata.getInstance<ZdGrid>('taxesDetail');
             
          taxesGrid.datasource.updateData(response.data.dataset.data);
        });
          
        this.hideLoading();
      } catch (error) {
        this.Utils.alertService(error, 'error');
        this.hideLoading();
      }
    }
  }
  
  public closeFormModal() {
    this.addForm.hide();
    this.deleteForm.hide();
  }
  
  public openFormModal() {
    this.addForm.show();
    
    this.loadFormFields();
  }

  public openAttachmentModal() {
    this.attachment.show();
  }

  public closeModalAttachment() {
    this.attachment.hide();
  }
  
  public openErroImportModal() {
    this.erroImportar.show();
  }
  
  public exportXLS() {
    const crosstab = Metadata.getInstance<CrosstabEditable>('cmp99000Crosstab');
    
    crosstab.getReport('XLS', I18n.translate('planilha'));
  }
  
  public cellLockedClass(params: ICellConditionsParam) {
    return this.cellXlsLock(params) ? 'locked-cell' : '';
  }

  public cellXlsLock({ cell }: ICellConditionsParam) {
    // console.log('a')
    return cell.col.includes('EST');
  }

  public rowXlsLock() {
    // console.log('a')
    return true;
  }

  public closeModalErroImport() {
    this.erroImportar.hide();
  }
  
  public toBase64 = (file: any) => new Promise((resolve, reject) => {
    const reader = new FileReader();
    reader.readAsDataURL(file);
    reader.onload = () => resolve(reader.result);
    reader.onerror = reject;
  });

  public async saveAttachment() {
    const fileInput : FileInput = Metadata.getInstance('file-input-modal');
    if (fileInput) {
      if (fileInput.value.length) {
        // const formData = new FormData();
        const b64Arq = await this.toBase64(fileInput.value[0]) as string;
        
        const file = {
          name: fileInput.value[0].name,
          content: b64Arq.split(',')[1],
        };
        const filters = this.getFilters();
        filters.CDOPERADOR = this.sessionInfos.CDOPERADOR;
        const row = {
          FILE: file,
          FILTER: filters,
        };
        
        // formData.append('file', fileInput.value[0], fileInput.value[0].name);
        const arrayErro: any = [];
      
        await Http.post('/uploadFile', {
          requestType: 'Row',
          row,
        }).then((response) => {
          response.data.dataset.data.forEach((x: any) => {
            if (x.DSERRO !== '') {
              arrayErro.push(x);
            } else {
              x.CDFILCENTCMP = this.cdFilCentCmp;
              this.arraySucesso.push(x);
            }
          });
        
          const cdArvProdValues = this.arraySucesso.map((item : any) => item.CDARVPROD);
          const minCdArvProd = Math.min(...cdArvProdValues);
          const maxCdArvProd = Math.max(...cdArvProdValues);
          this.filterFromImport.CDPRODINI = minCdArvProd;
          this.filterFromImport.CDPRODFIN = maxCdArvProd;
          const cdFilSoliValues = this.arraySucesso.map((item : any) => item.CDFILSOLI);
          const uniqueCdFilSoliValues = Array.from(new Set(cdFilSoliValues));
          this.filterFromImport.CDFILIAL = `_${uniqueCdFilSoliValues.join('_')}_`;
          if (arrayErro.length > 0) {
            this.erroImportar.show();
            setTimeout(() => {
              const Grid = Metadata.getInstance<ZdGrid>('gridErroPlanilha');
            
              Grid.datasource.updateData(arrayErro);
            }, 100);
          } else {
            this.importAction();
          }
          // this.filters = this.getFilters();
        });
        // this.modalText = `${fileCount} file(s) attached`;
      }
    }
    // this.attachment.hide();
  }
  
  public importAction() {
    // const grid = Metadata.getInstance<any>('cmp99000Grid');
     
    setTimeout(() => {
      const tabs = Metadata.getInstance<any>('tabsCmp99000');
      
      tabs.nextTab();
  
      this.currentTab = 'C';
    
      this.loadGrid().then(() => {
        this.closeFilterModal();
        this.closeModalErroImport();
        this.closeModalAttachment();
        this.arraySucesso = this.arraySucesso.filter((item: any) => {
          item.NRAPURPREC = this.nrapurprec;

          const match = this.dataGrid.find((responseItem: any) => responseItem.CDFILSOLI === item.CDFILSOLI
    && responseItem.CDPRODUTO === item.CDPRODUTO
    && responseItem.DSTIPO === 'CMP');

          if (match) {
            item.CDFORNECED_OLD = match.CDFORNECED_OLD;
            item.DTPROGENTR = match.DTPROGENTR.split(' ')[0];
            item.CDMARCA = match.CDMARCA;
            return true; // Keep the item in the array
          }
          return false; // Remove the item from the array
        });
        this.verifyBeforeGenerateEdited(this.arraySucesso);
      });
    }, 1000);
     
    //
  }
   
  public loadFormFields() {
    if (this.currentRow) {
      setTimeout(() => {
        const produto = Metadata.getInstance<any>('CDPRODUTOFORM');
        const fornecedor = Metadata.getInstance<any>('CDFORNECEDFORM');
        const cdfilial = Metadata.getInstance<any>('CDFILIALFORM');
        const marca = Metadata.getInstance<any>('CDMARCAFORM');
        const qtde = Metadata.getInstance<any>('QTSOLIPRODFORM');
        const vrCusto = Metadata.getInstance<any>('VRCUSTOFORM');
        
        fornecedor.disabled = false;
        fornecedor.datasource.filter.P_CDPRODUTO = this.currentRow.CDPRODUTO;
        produto.datasource.searchIn = '';
        produto.setValue(this.currentRow.CDPRODUTO);
        fornecedor.value = this.currentRow.CDFORNECED;
        marca.setValue([this.paraSupri.CDMARCA]);
        qtde.value = 0.000;
        vrCusto.value = null;
        
        if (this.sessionInfos.CDFILIAL !== this.cdFilCentCmp) {
          cdfilial.readonly = true;
        } else {
          cdfilial.readonly = false;
        }
      }, 500);
    }
  }
  
  public async validateItem(params:any) {
    try {
      this.showLoading('Gerando Apuração...');
      
      await Http.post('/verifyBeforeGenerate', params).then((response) => {
        this.hideLoading();
        
        if (response.data.dataset.data.length > 0) {
          this.inconsistencyModal.show();
         
          setTimeout(() => {
            const inconsistencyGrid = Metadata.getInstance<ZdGrid>('cmp99000inconsistencyGrid');
            
            inconsistencyGrid.datasource.updateData(response.data.dataset.data);
          }, 1000);
 
          return;
        }
        
        this.continueInconsistency();
      });
    } catch (error) {
      this.Utils.alertService('Erro inesperado, consulte o administrador de sistema', 'error');
      this.loadGrid();
      this.hideLoading();
    }
  }
  
  public async validateItemEdit(params:any) {
    try {
      this.showLoading('Verificando Inconsistências...');
      
      await Http.post('/verifyBeforeGenerate', params).then((response) => {
        const param = {
          rows: params.rows,
        };
        if (response.data.dataset.data.length > 0) {
          this.inconsistencyModal.show();
          
          this.inconsistencyParams = param;
          this.hideLoading();
          setTimeout(() => {
            const inconsistencyGrid = Metadata.getInstance<ZdGrid>('cmp99000inconsistencyGrid');
            response.data.dataset.data.edit = true;
            inconsistencyGrid.datasource.updateData(response.data.dataset.data);
          }, 1000);
        } else {
          this.saveEdited(params);
        }
      });
      return;
    } catch (error) {
      this.Utils.alertService('Erro inesperado, consulte o administrador de sistema', 'error');
      this.loadGrid();
      this.hideLoading();
    }
  }
  
  public async saveEdited(params:any) {
    // if(this.arraySucesso.length==0){
    const instance = Metadata.getInstance<CrosstabEditable>('cmp99000Crosstab');

    await Http.post('/saveEditedRows', params).then((response) => {
      this.hideLoading();
      if (response.data.dataset.data.success === true) {
        this.Utils.alertService('Salvo com sucesso!', 'success');
          
        instance.saveEditedRows();
        // if (this.modalCloseResolve) {
        // this.modalCloseResolve();
        // this.modalCloseResolve = null; // Reset the resolve function
        // }
        this.loadGrid();
      }
    }).catch(() => {
      this.Utils.alertService('Houve um erro ao tentar salvar os dados.', 'error');
      this.cancelEdit();
      if (this.modalCloseResolve) {
        this.modalCloseResolve();
        this.modalCloseResolve = null; // Reset the resolve function
      }
    });
    // }
    // else{
    //   await Http.post('/saveEditedRows', params).then((response) => {
     
    //   if (response.data.dataset.data.success === true) {
    //     this.Utils.alertService('Salvo com sucesso!', 'success');
    //   }
      
    //   this.loadGrid();
    // }).catch(() => {
    //   this.Utils.alertService('Houve um erro ao tentar salvar os dados.', 'error');
    //   this.cancelEdit();
    //   if (this.modalCloseResolve) {
    //     this.modalCloseResolve();
    //     this.modalCloseResolve = null; // Reset the resolve function
    //   }
    // });
    // }
  }
  
  public continueInconsistency() {
    if (this.inconsistencyParams.length === 0) {
      // this.showLoading('Gerando AF, aguarde...');
      
      setTimeout(() => {
        if (this.createOrGenerate === 'generate') {
          this.showLoading('Gerando AF, aguarde...');
          this.generateAfs();
         
          return;
        }
       
        if (this.createOrGenerate === 'generateCrossTab') {
          this.showLoading('Gerando AF, aguarde...');
          this.generateAfsCrossTab();
         
          return;
        }
        
        if (this.createOrGenerate === 'filter') {
          this.inconsistencyParams = [];
          this.fromFilter = false;
          this.closeInconsistencyModal();
          this.loadGrid();
          return;
        }
        
        this.create(this.createParams);
       
        this.createOrGenerate = '';
      }, 1000);
    } else {
      this.saveEdited(this.inconsistencyParams);
      this.inconsistencyParams = [];
      this.closeInconsistencyModal();
    }
  }

  public async closeGridEdited() {
    this.gridEdited.hide();
  }

  public async saveGridEdited() {
    this.gridEdited.hide();
    const instance = Metadata.getInstance<CrosstabEditable>('cmp99000Crosstab');
    const editedRows = instance.getEditedRows();
    if (editedRows.length > 0) {
      await this.saveEdit();
      await this.waitForModalClose();
    } else {
      this.cancelEdit();
    }
     
    if (this.evento.component && this.evento.component.name === 'filterButtonCT') {
      this.openFilterModal(this.evento);
      this.evento = null;
      return;
    }
    if (this.evento.component && this.evento.component.name === 'addCrossTab') {
      this.openFormModal();
      this.evento = null;
      return;
    }
    
    if (this.evento.component && this.evento.component.name === 'GERAAFCT') {
      this.verifyBeforeGenerateCrossTab();
      this.evento = null;
      this.gridEdited.hide();
      return;
    }
    
    if (this.evento.component && this.evento.component.name === 'addApurCrossTab') {
      this.openFilterModal(this.evento);
      this.evento = null;
      this.gridEdited.hide();
      return;
    }
    
    if (this.evento.component && this.evento.component.name === 'GERAAF') {
      this.verifyBeforeGenerate();
      this.evento = null;
      this.gridEdited.hide();
      return;
    }
    if (this.evento.component && this.evento.component.name === 'getInfoCT') {
      this.openFilterGetInfo(this.evento);
      this.evento = null;
      this.gridEdited.hide();
      return;
    }
    if (!this.evento.component && this.evento.field.name === 'CDARVPROD') {
      this.openFilterGetInfoCdarvprod(this.evento);
      this.evento = null;
      this.gridEdited.hide();
      return;
    }
    if (!this.evento.component && this.evento.field.name === 'NMPRODUTO') {
      this.clickNmProd(this.evento);
      this.evento = null;
      this.gridEdited.hide();
    }
    if (!this.evento.component && this.evento.field.name === 'QTTOTAL') {
      this.openDeleteForm(this.evento);
      this.evento = null;
      this.gridEdited.hide();
    }
  }
  
  public async callDeleteProcedure() {
    try {
      const form = Metadata.getInstance<Form>('dellFormInput');
      this.del = form;
      const params = this.getFilters();
      params.CDFORNECED = this.del.internalValue.CDFORNECEDFORMDEL.CDFORNECED;
      params.CDMARCA = this.del.internalValue.CDMARCAFORMDEL.length > 0 ? this.mountArrayFilter(this.del.internalValue.CDMARCAFORMDEL, 'CDMARCA') : 'T';
      params.CDPRODINI = this.del.internalValue.CDPRODUTOFORMDEL.CDARVPROD;
      params.CDPRODFIN = this.del.internalValue.CDPRODUTOFORMDEL.CDARVPROD;
      params.CDFILIAL = this.del.internalValue.CDFILIALFORMDEL && this.del.internalValue.CDFILIALFORMDEL.length > 0 ? this.mountArrayFilter(this.del.internalValue.CDFILIALFORMDEL, 'CDFILIAL') : 'T';
      
      const validateParams = {
        filter: params,
      };
      await Http.post('/callDeleteProcedure', validateParams).then(() => {
        this.deleteForm.hide();
        this.loadGrid();
      });
    } catch (error) {
      this.Utils.alertService('Erro inesperado, consulte o administrador de sistema', 'error');
      this.deleteForm.show();
    }
  }

  public get isMaskLoading() {
    return !this.maskP;
  }
  
  // Função para aplicar a máscara ao valor
  public applyMask = (value: string) => {
    let maskedValue = '';
    let valueIndex = 0;
    const mask = this.maskP;
    for (let i = 0; i < mask.length; i += 1) {
      if (mask[i] === 'a') {
      // Caractere alfabético
        maskedValue += value[valueIndex];
        valueIndex += 1;
      } else if (mask[i] === '9') {
      // Dígito numérico
        maskedValue += value[valueIndex];
        valueIndex += 1;
      } else {
      // Caractere de máscara (como '.', '-', etc)
        maskedValue += mask[i];
      }

      if (valueIndex >= value.length) {
        break;
      }
    }

    return maskedValue;
  };
  
  public async validateBeforecreate() {
    const form = Metadata.getInstance<Form>('addFormInput');
    
    this.createForm = form;
    const valid = form.validate();

    if (!valid) {
      this.Utils.alertService('Preencha todos os campos obrigatórios!', 'error');

      return;
    }
    
    const params = this.getFilters();

    params.CDFORNECED = this.createForm.internalValue.CDFORNECEDFORM.CDFORNECED;
    params.CDMARCA = this.createForm.internalValue.CDMARCAFORM.length > 0 ? this.mountArrayFilter(this.createForm.internalValue.CDMARCAFORM, 'CDMARCA') : 'T';
    params.CDPRODINI = this.createForm.internalValue.CDPRODUTOFORM.CDARVPROD;
    params.CDPRODFIN = this.createForm.internalValue.CDPRODUTOFORM.CDARVPROD;
    params.QTSOLIPROD = this.createForm.internalValue.QTSOLIPRODFORM;
    params.VRCUSTO = this.createForm.internalValue.VRCUSTOFORM;
    params.CDFILIAL = this.createForm.internalValue.CDFILIALFORM && this.createForm.internalValue.CDFILIALFORM.length > 0 ? this.mountArrayFilter(this.createForm.internalValue.CDFILIALFORM, 'CDFILIAL') : 'T';
    params.CDFORNERELACAF = 'T';
    params.TIPOPREVISAO = 'N';
    params.DTINICIAL = null;
    params.DTFINAL = null;
    params.DTENTREGA = null;
    params.QTDIAESTOQUE = null;
    params.TIPOTELA = this.createForm.internalValue.VRCUSTOFORM > 0 ? 'C' : 'T';
    params.NRAPURPREC = params.NRAPURPREC === '' ? this.nrapurprec : params.NRAPURPREC;
    const validateParams = {
      rows: params,
      CDOPERADOR: this.cdComprador,
      filters: params,
    };
    
    this.createOrGenerate = 'create';
    this.createParams = params;
    
    this.addForm.hide();
    
    this.validateItem(validateParams);
  }
  
  public async validateBeforecreateSave(params : any) {
    // const params = this.getFilters();
    const value = Metadata.getInstance<any>('CDFORNECED');
    
    value.datasource.get().then((success: any) => {
      const CDFORNECED = success.find((x : any) => x.NRINSJURFORN === params.rows[0].NRINSJURFORN || x.CDEXFORNECED === params.rows[0].NRINSJURFORN);
      params.filters.CDFORNECED = CDFORNECED.CDFORNECED ? CDFORNECED.CDFORNECED : null;
      params.filters.CDPRODINI = params.rows[0].CDARVPROD;
      params.filters.CDPRODFIN = params.rows[0].CDARVPROD;
      params.filters.VRCUSTO = params.rows[0].VRCUSTO;
      params.filters.TIPOTELA = 'C';
      params.filters.DTENTREGA = null;
      params.filters.TIPOTELA = null;
      params.filters.TIPOTELA = null;
      params.filters.QTSOLIPROD = 0;
      params.filters.QTDIAESTOQUE = null;
      params.filters.NRAPURPREC = params.filters.NRAPURPREC === '' ? this.nrapurprec : params.filters.NRAPURPREC;
      const validateParams = {
        rows: params.filters,
        CDOPERADOR: this.cdComprador,
        filters: params.filters,
      };
      
      this.createOrGenerate = 'create';
      this.createParams = validateParams.rows;
      this.validateItem(validateParams);
    });
  }
  
  public create(params:any) {
    this.closeInconsistencyModal();
    const instance = Metadata.getInstance<CrosstabEditable>('cmp99000Crosstab');
    
    this.showLoading('Adicionando...');
    try {
      Http.post('/generateProcedure', params).then((response) => {
        if (response.data !== undefined) {
          if (response.data.dataset !== undefined) {
            if (response.data.dataset.data[0] === 'success') {
              this.Utils.alertService('Operação realizada com sucesso', 'success');
            }
          } else {
            this.Utils.alertService(response.data.error, 'error');
          }
        } else {
          this.Utils.alertService(response.error, 'error');
        }

        this.loadGrid();
        this.addForm.hide();
        // this.hideLoading();
        instance.saveEditedRows();
      }).catch((error) => {
        this.Utils.alertService(error.message, 'error');
        
        this.loadGrid();
        this.hideLoading();
        this.addForm.hide();
      });
    } catch (error) {
      this.Utils.alertService('Erro inesperado, consulte o administrador de sistema', 'error');
      this.loadGrid();
      this.hideLoading();
      this.addForm.hide();
    }
  }
  
  private events: any = {
    click: (component: any) => {
      if (component.component.name === 'yes') {
        this.openAnaliseAf();
      }
      this.loadGrid();
      DialogService.hide();
    },
  };

  public showDialog() {
    DialogService.show({
      name: 'buttons-dialog',
      type: 'info',
      title: 'Informação',
      text: 'Deseja acessar a tela de Análise de Autorização de Fornecedor?',
      buttons: [
        {
          name: 'yes', component: 'ZdButton', label: 'Sim', events: this.events, outline: true,
        },
        {
          name: 'no', component: 'ZdButton', label: 'Não', events: this.events,
        },
      ],
    });
  }

  public openAnaliseAf() {
    window.top.parent.postMessage({
      type: 'openAnalysis',
      realData: this.filters,
    }, window.location.ancestorOrigins[1]);
  }
  
  public reloadDetails() {
    this.gridDetailModal.hide();
    this.getDetails();
  }
  
  public closeGridDetailModal() {
    this.gridDetailModal.hide();
  }
  
  public closeInconsistencyModal(): void {
    this.inconsistencyModal?.hide();
  }
  
  private waitForModalClose(): Promise<void> {
    return new Promise<void>((resolve) => {
      this.modalCloseResolve = resolve;
    });
  }
  
  public conditionsCmp(component: any) {
    const v = this.dataGrid.find((x: any) => x.CDARVPROD === component.cell.row[0]
                                           && x.NRINSJURFORN === component.cell.row[2]
                                           && x.VRPRECUNIAP === component.cell.row[3]
                                           && x.QTTOTAL === component.cell.row[4]
                                           && x.VRCUSTO === component.cell.row[5]);
                                           
    if (v.QTTOTALAF > 0) {
      return {
        opacity: '50%',
        
      };
    }
    
    if (v.QTTOTALCMP > 0) {
      return {
        'background-color': 'rgb(83 255 40 / 25%)',
      };
    }
    
    if (v.QTTOTALCMP === 0 && v.VRCUSTO !== '0') {
      return {
        'background-color': 'rgb(252 253 40 / 25%)',
      };
    }
    
    return false;
  }
  
  public editableConditionsVrcusto(row: IDictionary<any>) {
    return row;
  }
    
  public backgroundColumn({ field }: IFieldConditionsParam) {
    if (field.name === 'NMPRODUTO') {
      return {
        'background-color': '#C0C0C0',
        'font-size': '14px',
      };
    }
   
    if (field.name === 'NRINSJURFORN') {
      return {
        'background-color': '#80fdb9',
        'font-size': '14px',
      };
    }
    
    if (field.name === 'VRPRECUNIAP') {
      return {
        'background-color': '#00e6e6',
      };
    }
   
    if (field.name === 'QTTOTAL') {
      return {
        'font-size': '10px',
        'background-color': '#fff28c',
      };
    }

    return {
      'background-color': '#d4ffff',
    };
  }

  public cellStyle() {
    return {
      width: '10px !important',
      padding: '0px 0px 0px 0px',
    };
  }

  public sortp = (a: any, b: any) => {
    if (parseInt(a, 10) < parseInt(b, 10)) return -1;

    if (parseInt(a, 10) === parseInt(b, 10)) return 0;

    return 1;
  };

  public sort = (a: number, b: number) => {
    if (a < b) return 1;

    if (a === b) return 0;

    return -1;
  };
  
  public sortUnity = (a: number, b: number) => {
    if (a > b) return 1;

    if (a === b) return 0;

    return -1;
  };
  
  get isNotEditing() {
    return !this.editing;
  }

  public async saveEdit() {
    const instance = Metadata.getInstance<CrosstabEditable>('cmp99000Crosstab');
    const editedRows = instance.getEditedRows();
    
    try {
      this.verifyBeforeGenerateEdited(editedRows).then(() => {
         
      });
    } catch (e) {
      this.Utils.alertService('Houve um erro ao tentar salvar os dados.', 'error');
    }
  }

  public cancelEdit() {
    const instance = Metadata.getInstance<CrosstabEditable>('cmp99000Crosstab');
    instance.cancelEditedRows();
  }
  
  public openFilterGetInfo({ event }: IGridEvent) {
    event?.preventDefault();
    this.filterDetailCT.show();
  }
  
  public openDeleteForm({ event, rows }: any) {
    event?.preventDefault();
    this.deleteForm.show();
    
    const unidades: Array<any> = [];
    const marcas: Array<any> = [];
      
    rows.forEach((r: any) => {
      const marca = r.CDMARCA;
      
      if (!marcas.includes(marca)) {
        marcas.push(marca);
      }
    });
    // if (this.filterForm.internalValue.CDFILIAL.length > 0) {
    //   this.filterForm.internalValue.CDFILIAL.forEach((f: any) => {
    //     unidades.push(f.CDFILIAL);
    //   });
    // }
  
    setTimeout(() => {
      const produto = Metadata.getInstance<any>('CDPRODUTOFORMDEL');
      const cdfilial = Metadata.getInstance<any>('CDFILIALFORMDEL');
      const marca = Metadata.getInstance<any>('CDMARCAFORMDEL');
      const forneced = Metadata.getInstance<any>('CDFORNECEDFORMDEL');
      forneced.datasource.get().then(() => {
        forneced.value = rows[0].CDFORNECED;
      });
      produto.datasource.filter.CDARVPROD = rows[0].CDARVPROD;
      produto.datasource.get().then((success: any) => {
        produto.setValue(success[0].CDARVPROD);
        produto.datasource.filter = [];
      });
       
      cdfilial.datasource.get().then(() => {
        cdfilial.setValue(unidades);
      });
      marca.datasource.get().then(() => {
        marca.setValue(marcas);
      });
    }, 1000);
  }
  
  public openFilterGetInfoCdarvprod({ event, rows }: any) {
    event?.preventDefault();
    this.filterDetailCT.show();
    
    setTimeout(() => {
      const produto = Metadata.getInstance<any>('CDPRODUTOFORMCT');
      const unidade = Metadata.getInstance<any>('CDFILIALFORMCT');
      const marca = Metadata.getInstance<any>('CDMARCAFORMCT');
  
      produto.datasource.filter.CDARVPROD = rows[0].CDARVPROD;
      produto.datasource.get().then((success: any) => {
        produto.setValue(success[0].CDARVPROD);
        produto.datasource.filter = [];
      });
      unidade.datasource.get().then((success: any) => {
        const arr: Array<any> = [];
        arr.push(success[0].CDFILIAL);
        unidade.setValue(arr);
      });
      marca.datasource.get().then((success: any) => {
        marca.setValue(success[0].CDMARCA);
      });
    }, 100);
  }
  
  public editableConditions(row: IDictionary<any>) {
    // const v = this.dataGrid.find((x: any) => x.CDARVPROD === row.cell.row[0]
    //                                       && x.NRINSJURFORN === row.cell.row[2]
    //                                       && x.VRPRECUNIAP === row.cell.row[3]
    //                                       && x.QTTOTAL === row.cell.row[4]
    //                                       && x.VRCUSTO === row.cell.row[5]
    //                                       && x.QTSOLIPROD === row.cell.value);
    
    return row.cell.col[1] === 'CMP';//  && row.cell.row[1] !== null && row.cell.row[5] !== '0'
  }
  
  public editableConditionsForn(row: IDictionary<any>) {
    return row.value !== null;
  }
  
  public clickNmProd({ rows }: any) {
    this.addForm.show();
      
    const unidades: Array<any> = [];
    const marcas: Array<any> = [];
      
    rows.forEach((r: any) => {
      const marca = r.CDMARCA;
        
      if (!marcas.includes(marca)) {
        marcas.push(marca);
      }
    });
    if (this.filterForm.internalValue.CDFILIAL.length > 0) {
      this.filterForm.internalValue.CDFILIAL.forEach((f: any) => {
        unidades.push(f.CDFILIAL);
      });
    }
      
    /* else {
        this.filterForm.internalValue.CDFILIAL.forEach((r: any) => {
          const unidade = r.CDFILSOLI;
          const marca = r.CDMARCA;
          
          if (!unidades.includes(unidade)) {
            unidades.push(unidade);
          }
          
          if (!marcas.includes(marca)) {
            marcas.push(marca);
          }
        });
      } */
      
    setTimeout(() => {
      const produto = Metadata.getInstance<any>('CDPRODUTOFORM');
      const cdfilial = Metadata.getInstance<any>('CDFILIALFORM');
      const marca = Metadata.getInstance<any>('CDMARCAFORM');
      // const forneced = Metadata.getInstance<any>('CDFORNECEDFORM');
      // forneced.datasource.get().then(() => {
      //   forneced.value = rows[0].CDFORNECED;
      // });
      produto.datasource.filter.CDARVPROD = rows[0].CDARVPROD;
      produto.datasource.get().then((success: any) => {
        produto.setValue(success[0].CDARVPROD);
        produto.datasource.filter = [];
      });
         
      cdfilial.datasource.get().then(() => {
        cdfilial.setValue(unidades);
      });
      marca.datasource.get().then(() => {
        marca.setValue(marcas);
      });
    }, 1000);
  }
  
  public rowClickCrossTab({ rows, field, event }: IEventParam<any>) {
    if (field.name === 'CDARVPROD') {
      // if (!this.editing) {
      // this.openGridEdited({ rows, field, event });
      this.openFilterGetInfoCdarvprod({ event, rows });
      // } else {
      //   this.evento = { event, rows };
      //   this.saveGridEdited();
      // }
    }
    if (field.name === 'NMPRODUTO') {
      this.evento = { rows, field, event };
      if (!this.editing) {
        this.clickNmProd(this.evento);
        // this.openFilterGetInfoCdarvprod({ event, rows });
      } else {
        // this.evento ={ event, rows };
        this.saveGridEdited();
      }
      // this.clickNmProd(this.evento);
    }
    if (field.name === 'QTTOTAL' && rows[0].QTTOTAL > 0 && rows[0].QTTOTALAF > 0) {
      if (!this.editing) {
        this.openDeleteForm({ event, rows });
      } else {
        this.evento = { rows, field, event };
        this.saveGridEdited();
      }
    }
  }
}
