import { AlertService } from '@zeedhi/common';

export class Utils {
  public productMask(value: any) {
    if (typeof value === 'string') {
      const productIdLenght: any = value.length;

      const masks: any = {
        20: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})/, '$1.$2.$3.$4.$5.$6.$7.$8'),
        19: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{2})/, '$1.$2.$3.$4.$5.$6.$7.$8'),
        18: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{1})/, '$1.$2.$3.$4.$5.$6.$7.$8'),
        17: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})/, '$1.$2.$3.$4.$5.$6.$7'),
        16: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{2})/, '$1.$2.$3.$4.$5.$6.$7'),
        15: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{1})/, '$1.$2.$3.$4.$5.$6.$7'),
        14: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})/, '$1.$2.$3.$4.$5.$6'),
        13: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{2})/, '$1.$2.$3.$4.$5.$6'),
        12: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})([A-Za-z0-9_]{1})/, '$1.$2.$3.$4.$5.$6'),
        11: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{3})/, '$1.$2.$3.$4.$5'),
        10: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{2})/, '$1.$2.$3.$4.$5'),
        9: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})([A-Za-z0-9_]{1})/, '$1.$2.$3.$4.$5'),
        8: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{3})/, '$1.$2.$3.$4'),
        7: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})/, '$1.$2.$3.$4'),
        6: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})([A-Za-z0-9_]{1})/, '$1.$2.$3.$4'),
        5: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{2})/, '$1.$2.$3'),
        4: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})([A-Za-z0-9_]{1})/, '$1.$2.$3'),
        3: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{2})/, '$1.$2'),
        2: value.replace(/([A-Za-z0-9_]{1})([A-Za-z0-9_]{1})/, '$1.$2'),
        1: value,
      };
    
      return masks[productIdLenght] ?? value;
    }
    return value;
  }
  
  public fornMask(value: any) {
    if (value.length === 11) {
      return '###.###.###-##';
    }
      
    return '##.###.###/####-##';
  }
  
  public alertService(message: any, type: any) {
    AlertService.show({
      top: true,
      right: true,
      timeout: 5000,
      name: 'noData',
      text: message,
      color: type,
    });
  }
}
