import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import TeknisaComponents from '@zeedhi/teknisa-components-vuetify';
import { ZdCrosstab, ZdCrosstabEditable } from '@zeedhi/zd-crosstab';
import { Icons } from '@zeedhi/common';
import { Messages, Metadata } from '@zeedhi/core';
import controllers from '../controllers';
import config from '../config/config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';

Icons.addIcons({
  iconName: 'mdi-icon-id',
});

Vue.use(Zeedhi, {
  controllers,
  config,
});
Vue.use(ZeedhiComponents);

Vue.use(TeknisaComponents);

Vue.component('ZdCrosstab', ZdCrosstab);
Vue.component('ZdCrosstabEditable', ZdCrosstabEditable);

vuetify.framework.icons.values = Icons.getIcons() as any;

const loadMessages = async () => {
  const messages = await Metadata.get('json/messages', true);
  const wordsEsCl = await Metadata.get('json/words/es_cl', true); // Espanhol padrão
  const wordsEnUs = await Metadata.get('json/words/en_us', true); // Inglês padrão

  Messages.add({
    'pt-BR': {
      translation: {
        ...messages,
      },
    },
    'es-CL': {
      translation: {
        ...wordsEsCl,
      },
    },
    'en-US': {
      translation: {
        ...wordsEnUs,
      },
    },
  });
};

loadMessages();
